import type { NobjcObject } from "objc-js";
import type { _NSImage } from "../AppKit/NSImage.js";
import type { _NSPasteboard } from "../AppKit/NSPasteboard.js";
import type { _NSUserInterfaceValidations } from "../AppKit/NSUserInterfaceValidations.js";
import type { _NSView } from "../AppKit/NSView.js";
import type { _NSWindow } from "../AppKit/NSWindow.js";
import type { _NSArray } from "../Foundation/NSArray.js";
import type { _NSDictionary } from "../Foundation/NSDictionary.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { _NSURL } from "../Foundation/NSURL.js";
import type { _NSUndoManager } from "../Foundation/NSUndoManager.js";
import type { _DOMCSSStyleDeclaration } from "./DOMCSSStyleDeclaration.js";
import type { _DOMDocument } from "./DOMDocument.js";
import type { _DOMElement } from "./DOMElement.js";
import type { _DOMNode } from "./DOMNode.js";
import type { _DOMRange } from "./DOMRange.js";
import type { _WebArchive } from "./WebArchive.js";
import type { _WebBackForwardList } from "./WebBackForwardList.js";
import type { _WebDownloadDelegate } from "./WebDownloadDelegate.js";
import type { _WebEditingDelegate } from "./WebEditingDelegate.js";
import type { _WebFrame } from "./WebFrame.js";
import type { _WebFrameLoadDelegate } from "./WebFrameLoadDelegate.js";
import type { _WebHistoryItem } from "./WebHistoryItem.js";
import type { _WebPolicyDelegate } from "./WebPolicyDelegate.js";
import type { _WebPreferences } from "./WebPreferences.js";
import type { _WebResourceLoadDelegate } from "./WebResourceLoadDelegate.js";
import type { _WebScriptObject } from "./WebScriptObject.js";
import type { _WebUIDelegate } from "./WebUIDelegate.js";
import type { CGPoint } from "../structs/CGPoint.js";
import type { CGRect } from "../structs/CGRect.js";
import type { NSSelectionAffinity } from "../AppKit/NSSelectionAffinity.js";
export declare class _WebView extends _NSView {
    static alloc(): _WebView;
    static new(): _WebView;
    init(): _WebView;
    /**
     * @method canShowMIMEType: @abstract Checks if the WebKit can show content of a certain MIME type. @param MIMEType The MIME type to check. @result YES if the WebKit can show content with MIMEtype.
     */
    static canShowMIMEType$(MIMEType: _NSString): boolean;
    /**
     * @method canShowMIMETypeAsHTML: @abstract Checks if the MIME type is a type that the WebKit will interpret as HTML. @param MIMEType The MIME type to check. @result YES if the MIMEtype in an HTML type.
     */
    static canShowMIMETypeAsHTML$(MIMEType: _NSString): boolean;
    /**
     * @method MIMETypesShownAsHTML @result Returns an array of NSStrings that describe the MIME types WebKit will attempt to render as HTML.
     */
    static MIMETypesShownAsHTML(): _NSArray;
    /**
     * @method setMIMETypesShownAsHTML: @discussion Sets the array of NSString MIME types that WebKit will attempt to render as HTML. Typically you will retrieve the built-in array using MIMETypesShownAsHTML and add additional MIME types to that array.
     */
    static setMIMETypesShownAsHTML$(MIMETypes: _NSArray): void;
    /**
     * @method URLFromPasteboard: @abstract Returns a URL from a pasteboard @param pasteboard The pasteboard with a URL @result A URL if the pasteboard has one. Nil if it does not. @discussion This method differs than NSURL's URLFromPasteboard method in that it tries multiple pasteboard types including NSURLPboardType to find a URL on the pasteboard.
     */
    static URLFromPasteboard$(pasteboard: _NSPasteboard): _NSURL;
    /**
     * @method URLTitleFromPasteboard: @abstract Returns a URL title from a pasteboard @param pasteboard The pasteboard with a URL title @result A URL title if the pasteboard has one. Nil if it does not. @discussion This method returns a title that refers a URL on the pasteboard. An example of this is the link label which is the text inside the anchor tag.
     */
    static URLTitleFromPasteboard$(pasteboard: _NSPasteboard): _NSString;
    /**
     * @method registerURLSchemeAsLocal: @abstract Adds the scheme to the list of schemes to be treated as local. @param scheme The scheme to register
     */
    static registerURLSchemeAsLocal$(scheme: _NSString): void;
    /**
     * @method registerViewClass:representationClass:forMIMEType: @discussion Register classes that implement WebDocumentView and WebDocumentRepresentation respectively. A document class may register for a primary MIME type by excluding a subtype, i.e. "video/" will match the document class with all video types. More specific matching takes precedence over general matching. @param viewClass The WebDocumentView class to use to render data for a given MIME type. @param representationClass The WebDocumentRepresentation class to use to represent data of the given MIME type. @param MIMEType The MIME type to represent with an object of the given class.
     */
    static registerViewClass$representationClass$forMIMEType$(viewClass: NobjcObject, representationClass: NobjcObject, MIMEType: _NSString): void;
    /**
     * @method initWithFrame:frameName:groupName: @abstract The designated initializer for WebView. @discussion Initialize a WebView with the supplied parameters. This method will create a main WebFrame with the view. Passing a top level frame name is useful if you handle a targetted frame navigation that would normally open a window in some other way that still ends up creating a new WebView. @param frame The frame used to create the view. @param frameName The name to use for the top level frame. May be nil. @param groupName The name of the webView set to which this webView will be added. May be nil. @result Returns an initialized WebView.
     */
    initWithFrame$frameName$groupName$(frame: CGRect, frameName: _NSString, groupName: _NSString): _WebView;
    /**
     * @method close @abstract Closes the receiver, unloading its web page and canceling any pending loads. Once the receiver has closed, it will no longer respond to requests or fire delegate methods. (However, the -close method itself may fire delegate methods.) @discussion A garbage collected application is required to call close when the receiver is no longer needed. The close method will be called automatically when the window or hostWindow closes and shouldCloseWithWindow returns YES. A non-garbage collected application can still call close, providing a convenient way to prevent receiver from doing any more loading and firing any future delegate methods.
     */
    close(): void;
    /**
     * @method setMaintainsBackForwardList: @abstract Enable or disable the use of a backforward list for this webView. @param flag Turns use of the back forward list on or off
     */
    setMaintainsBackForwardList$(flag: boolean): void;
    /**
     * @method goBack @abstract Go back to the previous URL in the backforward list. @result YES if able to go back in the backforward list, NO otherwise.
     */
    goBack(): boolean;
    /**
     * @method goForward @abstract Go forward to the next URL in the backforward list. @result YES if able to go forward in the backforward list, NO otherwise.
     */
    goForward(): boolean;
    /**
     * @method goToBackForwardItem: @abstract Go back or forward to an item in the backforward list. @result YES if able to go to the item, NO otherwise.
     */
    goToBackForwardItem$(item: _WebHistoryItem): boolean;
    /**
     * @method userAgentForURL: @abstract Get the appropriate user-agent string for a particular URL. @param URL The URL. @result The user-agent string for the supplied URL.
     */
    userAgentForURL$(URL: _NSURL): _NSString;
    /**
     * @method stringByEvaluatingJavaScriptFromString: @param script The text of the JavaScript. @result The result of the script, converted to a string, or nil for failure.
     */
    stringByEvaluatingJavaScriptFromString$(script: _NSString): _NSString;
    /**
     * @method searchFor:direction:caseSensitive: @abstract Searches a document view for a string and highlights the string if it is found. Starts the search from the current selection. Will search across all frames. @param string The string to search for. @param forward YES to search forward, NO to seach backwards. @param caseFlag YES to for case-sensitive search, NO for case-insensitive search. @result YES if found, NO if not found.
     */
    searchFor$direction$caseSensitive$wrap$(string_: _NSString, forward: boolean, caseFlag: boolean, wrapFlag: boolean): boolean;
    /**
     * @method elementAtPoint: @param point A point in the coordinates of the WebView @result An element dictionary describing the point
     */
    elementAtPoint$(point: CGPoint): _NSDictionary;
    /**
     * @method writeSelectionWithPasteboardTypes:toPasteboard: @abstract Writes the current selection to the pasteboard @param types The types that WebView will write to the pasteboard @param pasteboard The pasteboard to write to
     */
    writeSelectionWithPasteboardTypes$toPasteboard$(types: _NSArray, pasteboard: _NSPasteboard): void;
    /**
     * @method pasteboardTypesForElement: @abstract Returns the pasteboard types that WebView can use for an element @param element The element
     */
    pasteboardTypesForElement$(element: _NSDictionary): _NSArray;
    /**
     * @method writeElement:withPasteboardTypes:toPasteboard: @abstract Writes an element to the pasteboard @param element The element to write to the pasteboard @param types The types that WebView will write to the pasteboard @param pasteboard The pasteboard to write to
     */
    writeElement$withPasteboardTypes$toPasteboard$(element: _NSDictionary, types: _NSArray, pasteboard: _NSPasteboard): void;
    /**
     * @method moveDragCaretToPoint: @param point A point in the coordinates of the WebView @discussion This method moves the caret that shows where something being dragged will be dropped. It may cause the WebView to scroll to make the new position of the drag caret visible.
     */
    moveDragCaretToPoint$(point: CGPoint): void;
    /** @method removeDragCaret @abstract Removes the drag caret from the WebView */
    removeDragCaret(): void;
    takeStringURLFrom$(sender: NobjcObject): void;
    stopLoading$(sender: NobjcObject): void;
    reload$(sender: NobjcObject): void;
    reloadFromOrigin$(sender: NobjcObject): void;
    goBack$(sender: NobjcObject): void;
    goForward$(sender: NobjcObject): void;
    makeTextLarger$(sender: NobjcObject): void;
    makeTextSmaller$(sender: NobjcObject): void;
    makeTextStandardSize$(sender: NobjcObject): void;
    toggleContinuousSpellChecking$(sender: NobjcObject): void;
    toggleSmartInsertDelete$(sender: NobjcObject): void;
    computedStyleForElement$pseudoElement$(element: _DOMElement, pseudoElement: _NSString): _DOMCSSStyleDeclaration;
    editableDOMRangeForPoint$(point: CGPoint): _DOMRange;
    setSelectedDOMRange$affinity$(range: _DOMRange, selectionAffinity: NSSelectionAffinity): void;
    styleDeclarationWithText$(text: _NSString): _DOMCSSStyleDeclaration;
    replaceSelectionWithNode$(node: _DOMNode): void;
    replaceSelectionWithText$(text: _NSString): void;
    replaceSelectionWithMarkupString$(markupString: _NSString): void;
    replaceSelectionWithArchive$(archive: _WebArchive): void;
    deleteSelection(): void;
    applyStyle$(style: _DOMCSSStyleDeclaration): void;
    copy$(sender: NobjcObject): void;
    cut$(sender: NobjcObject): void;
    paste$(sender: NobjcObject): void;
    copyFont$(sender: NobjcObject): void;
    pasteFont$(sender: NobjcObject): void;
    delete$(sender: NobjcObject): void;
    pasteAsPlainText$(sender: NobjcObject): void;
    pasteAsRichText$(sender: NobjcObject): void;
    changeFont$(sender: NobjcObject): void;
    changeAttributes$(sender: NobjcObject): void;
    changeDocumentBackgroundColor$(sender: NobjcObject): void;
    changeColor$(sender: NobjcObject): void;
    alignCenter$(sender: NobjcObject): void;
    alignJustified$(sender: NobjcObject): void;
    alignLeft$(sender: NobjcObject): void;
    alignRight$(sender: NobjcObject): void;
    checkSpelling$(sender: NobjcObject): void;
    showGuessPanel$(sender: NobjcObject): void;
    performFindPanelAction$(sender: NobjcObject): void;
    startSpeaking$(sender: NobjcObject): void;
    stopSpeaking$(sender: NobjcObject): void;
    moveToBeginningOfSentence$(sender: NobjcObject): void;
    moveToBeginningOfSentenceAndModifySelection$(sender: NobjcObject): void;
    moveToEndOfSentence$(sender: NobjcObject): void;
    moveToEndOfSentenceAndModifySelection$(sender: NobjcObject): void;
    selectSentence$(sender: NobjcObject): void;
    overWrite$(sender: NobjcObject): void;
    /**
     * @property shouldCloseWithWindow @abstract Whether the receiver closes when either it's window or hostWindow closes. @discussion Defaults to YES in garbage collected applications, otherwise NO to maintain backwards compatibility.
     */
    shouldCloseWithWindow(): boolean;
    setShouldCloseWithWindow$(value: boolean): void;
    /** @property UIDelegate @abstract The WebView's WebUIDelegate. */
    UIDelegate(): _WebUIDelegate;
    setUIDelegate$(value: _WebUIDelegate): void;
    /** @property resourceLoadDelegate @abstract The WebView's WebResourceLoadDelegate. */
    resourceLoadDelegate(): _WebResourceLoadDelegate;
    setResourceLoadDelegate$(value: _WebResourceLoadDelegate): void;
    /** @property downloadDelegate @abstract The WebView's WebDownloadDelegate. */
    downloadDelegate(): _WebDownloadDelegate;
    setDownloadDelegate$(value: _WebDownloadDelegate): void;
    /**
     * @property frameLoadDelegate @abstract The WebView's WebFrameLoadDelegate delegate.
     */
    frameLoadDelegate(): _WebFrameLoadDelegate;
    setFrameLoadDelegate$(value: _WebFrameLoadDelegate): void;
    /** @property policyDelegate @abstract The WebView's WebPolicyDelegate. */
    policyDelegate(): _WebPolicyDelegate;
    setPolicyDelegate$(value: _WebPolicyDelegate): void;
    /**
     * @property mainFrame @abstract The top level frame. @discussion Note that even documents that are not framesets will have a mainFrame.
     */
    mainFrame(): _WebFrame;
    /**
     * @property selectedFrame @abstract The frame that has the active selection. @discussion Returns the frame that contains the first responder, if any. Otherwise returns the frame that contains a non-zero-length selection, if any. Returns nil if no frame meets these criteria.
     */
    selectedFrame(): _WebFrame;
    /** @property backForwardList @abstract The backforward list for this WebView. */
    backForwardList(): _WebBackForwardList;
    /** @property textSizeMultiplier @abstract The text size multipler. */
    textSizeMultiplier(): number;
    setTextSizeMultiplier$(value: number): void;
    /**
     * @property applicationNameForUserAgent @abstract The name of the application as used in the user-agent string.
     */
    applicationNameForUserAgent(): _NSString;
    setApplicationNameForUserAgent$(value: _NSString): void;
    /**
     * @property customUserAgent @abstract The custom user-agent string or nil if no custom user-agent string has been set. @discussion Setting this means that the webView should use this user-agent string instead of constructing a user-agent string for each URL. Setting it to nil causes the webView to construct the user-agent string for each URL for best results rendering web pages
     */
    customUserAgent(): _NSString;
    setCustomUserAgent$(value: _NSString): void;
    /**
     * @property supportsTextEncoding @abstract If the document view of the current web page can support different text encodings.
     */
    supportsTextEncoding(): boolean;
    /**
     * @property customTextEncodingName @abstract The custom text encoding name or nil if no custom text encoding name has been set. @discussion Make the page display with a different text encoding; stops any load in progress. The text encoding passed in overrides the normal text encoding smarts including what's specified in a web page's header or HTTP response. The text encoding automatically goes back to the default when the top level frame changes to a new location. Setting the text encoding name to nil makes the webView use default encoding rules.
     */
    customTextEncodingName(): _NSString;
    setCustomTextEncodingName$(value: _NSString): void;
    /**
     * @property mediaStyle @abstract The media style for the WebView. @discussion The mediaStyle will override the normal value of the CSS media property. Setting the value to nil will restore the normal value. The value will be nil unless explicitly set.
     */
    mediaStyle(): _NSString;
    setMediaStyle$(value: _NSString): void;
    /**
     * @property windowScriptObject @abstract A WebScriptObject that represents the window object from the script environment.
     */
    windowScriptObject(): _WebScriptObject;
    /**
     * @property preferences @abstract The preferences used by this WebView. @discussion This method will return [WebPreferences standardPreferences] if no other instance of WebPreferences has been set.
     */
    preferences(): _WebPreferences;
    setPreferences$(value: _WebPreferences): void;
    /**
     * @property preferencesIdentifier @abstract The WebPreferences key prefix. @discussion If the WebPreferences for this WebView are stored in the user defaults database, this string will be used as a key prefix.
     */
    preferencesIdentifier(): _NSString;
    setPreferencesIdentifier$(value: _NSString): void;
    /**
     * @property hostWindow @abstract The host window for the web view. @discussion Parts of WebKit (such as plug-ins and JavaScript) depend on a window to function properly. Set a host window so these parts continue to function even when the web view is not in an actual window.
     */
    hostWindow(): _NSWindow;
    setHostWindow$(value: _NSWindow): void;
    /**
     * @property groupName @abstract The group name for this WebView. @discussion JavaScript may access named frames within the same group.
     */
    groupName(): _NSString;
    setGroupName$(value: _NSString): void;
    /**
     * @property estimatedProgress @discussion An estimate of the percent complete for a document load. This value will range from 0 to 1.0 and, once a load completes, will remain at 1.0 until a new load starts, at which point it will be reset to 0. The value is an estimate based on the total number of bytes expected to be received for a document, including all it's possible subresources. For more accurate progress indication it is recommended that you implement a WebFrameLoadDelegate and a WebResourceLoadDelegate.
     */
    estimatedProgress(): number;
    /**
     * @property loading @abstract Whether there are any pending loads in this WebView.
     */
    loading(): boolean;
    /**
     * @property pasteboardTypesForSelection @abstract The pasteboard types that the WebView can use for the current selection
     */
    pasteboardTypesForSelection(): _NSArray;
    /**
     * @property drawsBackground @abstract Whether the receiver draws a default white background when the loaded page has no background specified.
     */
    drawsBackground(): boolean;
    setDrawsBackground$(value: boolean): void;
    /**
     * @property shouldUpdateWhileOffscreen @abstract Whether the WebView is always updated even when it is not in a window that is currently visible. @discussion If set to NO, then whenever the web view is not in a visible window, updates to the web page will not necessarily be rendered in the view. However, when the window is made visible, the view will be updated automatically. Not updating while hidden can improve performance. If set to is YES, hidden web views are always updated. This is the default.
     */
    shouldUpdateWhileOffscreen(): boolean;
    setShouldUpdateWhileOffscreen$(value: boolean): void;
    /** @property mainFrameURL @abstract The main frame's current URL. */
    mainFrameURL(): _NSString;
    setMainFrameURL$(value: _NSString): void;
    /** @property mainFrameDocument @abstract The main frame's DOMDocument. */
    mainFrameDocument(): _DOMDocument;
    /**
     * @property mainFrameTitle @abstract The main frame's title if any, otherwise an empty string.
     */
    mainFrameTitle(): _NSString;
    /**
     * @property mainFrameIcon @abstract The site icon for the current page loaded in the mainFrame, or nil.
     */
    mainFrameIcon(): _NSImage;
    canGoBack(): boolean;
    canGoForward(): boolean;
    canMakeTextLarger(): boolean;
    canMakeTextSmaller(): boolean;
    canMakeTextStandardSize(): boolean;
    selectedDOMRange(): _DOMRange;
    selectionAffinity(): NSSelectionAffinity;
    maintainsInactiveSelection(): boolean;
    editable(): boolean;
    setEditable$(value: boolean): void;
    typingStyle(): _DOMCSSStyleDeclaration;
    setTypingStyle$(value: _DOMCSSStyleDeclaration): void;
    smartInsertDeleteEnabled(): boolean;
    setSmartInsertDeleteEnabled$(value: boolean): void;
    continuousSpellCheckingEnabled(): boolean;
    setContinuousSpellCheckingEnabled$(value: boolean): void;
    spellCheckerDocumentTag(): number;
    undoManager(): _NSUndoManager;
    editingDelegate(): _WebEditingDelegate;
    setEditingDelegate$(value: _WebEditingDelegate): void;
}
export interface _WebView extends _NSUserInterfaceValidations {
}
